# Loading module:
# 1. archive.yml
# 2. recipe.yml
# 3. Load_decadal.R (V)

library(yaml)
library(startR)

dict <- read_yaml("/esarchive/scratch/aho/git/auto-s2s/conf/archive_decadal.yml")
names(dict$esarchive$Decadal)
  # to read from recipe:
  model <- 'HadGEM3'
  var <- 'tas'
  table <- 'Amon' # depend on var
  grid <- 'gr' #or archive???
  lat_min <- 0
  lat_max <- 10
  lon_min <- 0
  lon_max <- 10
  simu <- 'simulation' #'historical'
  sdates <- 1960:2015
  years <- 1961:2016
  member <- 'all'

path <- paste0('/esarchive/', #archive
               'exp/CMIP6/dcppA-hindcast/hadgem3-gc31-mm/', #archive
               'cmip6-dcppA-hindcast_i1p1/DCPP/MOHC/HadGEM3-GC31-MM/dcppA-hindcast/', #archive
               '$member$/', table, '/$var$/', grid, '/v*/$var$_*_s$sdate$_$member$_', grid, '_$sdate$11-$aux$03.nc')
fyears <- 1

  fmonths <- (1 + 12*(fyears[1]-1)) : (2 + 12*fyears[length(fyears)])
  exp <- Start(dat = path,
               var = var,
               sdate = paste0(sdates),
               aux = 'all',
               aux_depends = 'sdate',
               lat = values(list(lat_min, lat_max)),
               lon = values(list(lon_min, lon_max)),
               fmonth = indices(fmonths),
               member = member,
               synonims = list(fmonth = c('fmonth', 'time'),
                               lon = c('lon', 'longitude'),
                               lat = c('lat', 'latitude')),
               return_vars = list(lat = NULL, lon = NULL, fmonth = 'sdate'),
               lat_reorder = Sort(decreasing = F),
               lon_reorder = CircularSort(0, 360),
               num_procs = 1, retrieve = F)


path <- '/esarchive/obs/noaa/ghcn_v2/monthly_mean/$var$/$var$_$year$$month$.nc'

reference <- Start(dat = path,
                   var = var,
                   year = paste0(years_hist),
                   month = 'all',
                   lat = values(list(lat_min, lat_max)),
                   lon = values(list(lon_min, lon_max)),
                   synonims = list(lat = c('lat','latitude'), 
                                   lon = c('lon','longitude'),
                                   month = c('month','time')),
                   return_vars = list(lat = NULL, lon = NULL),
                   lat_reorder = Sort(decreasing = F),
                   lon_reorder = CircularSort(0, 360),
                   num_procs = 1, retrieve = FALSE)

all(attributes(hist)$Variables$common$lat == attributes(exp)$Variables$common$lat)
all(attributes(reference)$Variables$common$lat == attributes(hist)$Variables$common$lat)

