#-----------------------------------------------------------------
# 1st data (CORRECT)
path1 <- '/esarchive/exp/ecearth/a1ua/cmorfiles/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/r1i1p1f1/Omon/$var$/gn/v20190713/$var$_*_s$sdate$-$member$_gn_$aux$.nc'

data1 <- Start(dataset = path1,
               var = 'tos',
               sdate = paste0(1960),
               aux = indices(1),
               aux_depends = 'sdate',
               j = 'all',
               i = 'all',
               time = indices(1),
               member = 'r1i1p1f1',
               return_vars = list(j = NULL, i = NULL,
                                  latitude = NULL, longitude = NULL),
               retrieve = T)
lons1 <- attributes(data1)$Variables$common$longitude
lats1 <- attributes(data1)$Variables$common$latitude
dim(lons1)
dim(lats1)
dim(data1)
res1 <- CDORemap(drop(data1), lons1, lats1, grid = 'r100x50', method = 'bil', crop = FALSE)
#[1] "data_array final"
#  i   j 
#362 292 

dim(res1$data_array)
#lon lat 
#100  50 
s2dv::PlotEquiMap(t(res1$data_array), lon = res1$lons, lat = res1$lats)

(res1$data_array)[1:10, 50]
# [1] -1.588068 -1.586225 -1.584405 -1.582579 -1.580713 -1.578824 -1.577028
# [8] -1.575004 -1.572704 -1.570195

#-----------------
# don't drop (Correct. same as res1)
res1_2 <- CDORemap(data1, lons1, lats1, grid = 'r100x50', method = 'bil', crop = FALSE)
#[1] "subset final"
#   i    j time 
# 362  292    1 

s2dv::PlotEquiMap(res1_2$data_array, lon = res1_2$lons, lat = res1_2$lats)

identical(as.vector(res1$data_array), as.vector(res1_2$data_array))
#[1] TRUE

#==================================================================

# 2nd data (WRONG. swap lat and lon.)
path2 <- paste0('/esarchive/exp/CMIP6/dcppA-hindcast/cmcc-cm2-sr5/cmip6-dcppA-hindcast_i1p1/',
               'DCPP/CMCC/CMCC-CM2-SR5/dcppA-hindcast/$member$/Omon/$var$/gn/v20210312/',
               '$var$_*_s$sdate$-$member$_gn_$aux$.nc')

data2 <- Start(dataset = path2,
              var = 'tos',
              sdate = '1960',
              aux = 'all',
              aux_depends = 'sdate',
              j = 'all',
              i = 'all',
              time = indices(1),
              member = 'r1i1p1f1',
              return_vars = list(j = NULL, i = NULL,
                                 latitude = NULL, longitude = NULL),
              retrieve = T)

lons2 <- attributes(data2)$Variables$common$longitude
lats2 <- attributes(data2)$Variables$common$latitude
#WRONG
res2 <- CDORemap(drop(data2), lons2, lats2, grid = 'r100x50', method = 'bil', crop = FALSE)
#[1] "data_array final"
#  j   i 
#362 292 

dim(res2$data_array)
#lat lon 
# 50 100 

(res2$data_array)[50, 1:10]
# [1]        NA        NA        NA        NA        NA        NA -1.629947
# [8]        NA -1.662887        NA

s2dv::PlotEquiMap(res2$data_array, lon = res2$lons, lat = res2$lats)

#------------------------------
# don't drop (kind of correct; with strip)
res2_2 <- CDORemap(data2, lons2, lats2, grid = 'r100x50', method = 'bil', crop = FALSE)

#[1] "subset final"
#   j    i time 
# 362  292    1 
dim(res2_2$data_array)
#dataset     var   sdate     aux     lon     lat    time  member 
#      1       1       1       1     100      50       1       1 
drop(res2_2$data_array)[1:10, 50]
# [1] -1.795211 -1.795057 -1.794898 -1.794707 -1.794533 -1.794374 -1.794217
# [8] -1.793978 -1.793702 -1.793452

s2dv::PlotEquiMap(res2_2$data_array, lon = res2_2$lons, lat = res2_2$lats)

#--------------------------------
# 3 dim (same as res2, swap lat and lon)
tmp <- ClimProjDiags::Subset(data2, c(1,2,3,4,8),list(1,1,1,1,1), drop = 'selected')
res2_3 <- CDORemap(tmp, lons2, lats2, grid = 'r100x50', method = 'bil', crop = FALSE)
#[1] "data_array final"
#   j    i time 
# 362  292    1 
dim(res2_3$data_array)
# lat  lon time 
#  50  100    1 
(res2_3$data_array)[50, 1:10, 1]

s2dv::PlotEquiMap(res2_3$data_array, lon = res2_3$lons, lat = res2_3$lats)

