library(CSTools)
library(s2dv)

exp <- CST_Load(var = 'tasmax', exp = 'system5c3s', nmember = 1, sdates = '20170201',
                leadtimemax = 1, latmin = 27, latmax = 72, lonmin = -22, lonmax = 45,  
                output = 'lonlat')  

res <- CDORemap(data_array = exp$data, lats = exp$lat, lons = exp$lon,  
                grid = '/esarchive/recon/ecmwf/era5/daily/tasmax/tasmax_201702.nc',  
                method = 'nn')
