library(shiny)

# Define UI for application
 
shinyUI(pageWithSidebar(
  
  # Application title
  headerPanel("Inspect the ESARCHIVE"),
  
  # Sidebar with a slider input for number of observations
  sidebarPanel(
    textInput("var",
              "Variable:",
              value = "tas"),
    textInput("exp",
              "Experiment ID:",
              value = "ecearth/i00k"),
    sliderInput("nmember",
                "How many members?",
                min = 1, max = 10,
                value = c(1)),
    selectInput("obs",
              "Observation ID:",
              choices = c("erainterim",
                             "era40",
                             "merra",
                             "merra_v2",
                             "20thcr_v2",
                             "ncep-reanalysis"
                             ),
              selected = "erainterim"),
    dateInput("sdates",
              "Start date:",
              value = "1990-11-01"),
    sliderInput("ftime_range",
                "Forecast times:",
                min = 1,
                max = 12,
                value = c(1, 1)),
    sliderInput("lon_range",
                "Longitudes:",
                min = -360,
                max = 360,
                value = c(-20, 45)),
    sliderInput("lat_range",
                "Latitudes:",
                min = -90,
                max = 90,
                value = c(20, 75)),
    textInput("grid",
              "Target grid:",
              value = "r100x50"),
    actionButton("checkButton", "Check datasets")
  ),
  
  # Show a plot of the generated distribution
  mainPanel(
#    textOutput("equiMapExp")
    plotOutput("equiMapExp", height=400, width = 600),
    plotOutput("equiMapExpMean", height=400, width = 600),
    plotOutput("equiMapObs", height=400, width = 600)
  )
))
