path <- '/esarchive/exp/CMIP6/dcppA-hindcast/cmcc-cm2-sr5/cmip6-dcppA-hindcast_i1p1/DCPP/CMCC/CMCC-CM2-SR5/dcppA-hindcast/$member$/Amon/$var$/gn/$version$/$var$_*_s$sdate$-$member$_gn_$aux$.nc'
version <- list('r1i1p1f1' = 'v20210312', 'r2i1p1f1' = 'v20210312', 'r3i1p1f1' = 'v20210312', 
                'r4i1p1f1' = 'v20210312', 'r5i1p1f1' = 'v20210312', 'r6i1p1f1' = 'v20210312',                      'r7i1p1f1' = 'v20210719', 'r8i1p1f1' = 'v20210719', 'r9i1p1f1' = 'v20210719', 
                'r10i1p1f1' = 'v20210719')

data1 <- Start(dataset = path,
               var = 'tas',
               sdate = '1970', #paste0(1970:1972),
               fmonth = c(1), #c(1:12),
               aux = 'all',
               aux_depends = 'sdate',
               lat = values(list(-90, 90)), 
               lon = values(list(0, 359.9)),
               member = paste0('r',1:10,'i1p1f1'),
               version = version,
               version_depends = 'member',
               synonims = list(fmonth = c('fmonth', 'time'), 
                               lon = c('lon', 'longitude'), lat = c('lat', 'latitude')),
               return_vars = list(lat = 'dataset', lon = 'dataset'),
               num_procs = 1, retrieve = TRUE)

# Verification

file1 <- "/esarchive/exp/CMIP6/dcppA-hindcast/cmcc-cm2-sr5/cmip6-dcppA-hindcast_i1p1/DCPP/CMCC/CMCC-CM2-SR5/dcppA-hindcast/r1i1p1f1/Amon/tas/gn/v20210312/tas_Amon_CMCC-CM2-SR5_dcppA-hindcast_s1970-r1i1p1f1_gn_197011-198012.nc"
file2 <- "/esarchive/exp/CMIP6/dcppA-hindcast/cmcc-cm2-sr5/cmip6-dcppA-hindcast_i1p1/DCPP/CMCC/CMCC-CM2-SR5/dcppA-hindcast/r2i1p1f1/Amon/tas/gn/v20210312/tas_Amon_CMCC-CM2-SR5_dcppA-hindcast_s1970-r2i1p1f1_gn_197011-198012.nc"
file7 <- "/esarchive/exp/CMIP6/dcppA-hindcast/cmcc-cm2-sr5/cmip6-dcppA-hindcast_i1p1/DCPP/CMCC/CMCC-CM2-SR5/dcppA-hindcast/r7i1p1f1/Amon/tas/gn/v20210719/tas_Amon_CMCC-CM2-SR5_dcppA-hindcast_s1970-r7i1p1f1_gn_197011-198012.nc"

library(easyNCDF)
file <- NcOpen(file7)
arr <- NcToArray(file,
                 dim_indices = list(time = 1, lat = 1:192, lon = 1:288),
                 vars_to_read = 'tas')
NcClose(file)

all.equal(as.vector(drop(arr)[,]), as.vector(drop(data1)[,,1]))
#[1] TRUE
all.equal(as.vector(drop(arr)[,]), as.vector(drop(data1)[,,2]))
#[1] TRUE
all.equal(as.vector(drop(arr)[,]), as.vector(drop(data1)[,,7]))
#[1] TRUE

#--------------------------------------
data2 <- Start(dataset = path,
               var = 'tas',
               sdate = '1970', #paste0(1970:1972),
               fmonth = c(1), #c(1:12),
               aux = 'all',
               aux_depends = 'sdate',
               lat = values(list(-90, 90)),             
               lon = values(list(0, 359.9)),
               member = paste0('r',1:10,'i1p1f1'),
               version = version,
               version_depends = 'member',
               synonims = list(fmonth = c('fmonth', 'time'),
                               lon = c('lon', 'longitude'), lat = c('lat', 'latitude')),
               return_vars = list(lat = 'dataset', lon = 'dataset'),
               num_procs = 1, retrieve = F)

#fun <- function(data) {
#  output <- multiApply::Apply(data = data, target_dims = 'fmonth', fun = mean)$output1
#  return(output)
#}

fun <- function(x) {
return(x)
}

step <- Step(fun = fun,
#             use_libraries = c('multiApply'),
             target_dims = 'fmonth',
             output_dims = 'fmonth')#NULL)

wf <- AddStep(inputs = data2,
              step_fun = step)

res <- Compute(workflow = wf, chunks = list(member = 2)) 



#-------------------user-defined---------------------
  queue_host <- 'nord1'
  temp_dir <- '/gpfs/scratch/bsc32/bsc32734/startR_hpc/'
  ecflow_suite_dir <- '/home/Earth/aho/startR_local/'
#----------------------------------------------------

  res <- Compute(wf,
                 chunks = list(member = 2),
                 threads_load = 2,
                 threads_compute = 4,
                 cluster = list(queue_host = queue_host,
                   queue_type = 'lsf',
                   temp_dir = temp_dir,
                   cores_per_job = 2,
                   job_wallclock = '01:00',
                   max_jobs = 4,
                   extra_queue_params = list('#BSUB -q bsc_es'),
                   bidirectional = FALSE,
                   polling_period = 10
                 ),
                 ecflow_suite_dir = ecflow_suite_dir,
                 wait = TRUE
                 )  #$output1



