require('startR', .libPaths()[2])

path <- "/esarchive/exp/CMIP6/historical/cnrm-cm6-1/cmip6-historical_i0p1/CMIP/CNRM-CERFACS/CNRM-CM6-1/historical/$member$/day/$var$/gr/v20200101/$var$_day_CNRM-CM6-1_historical_$member$_gr_$period$.nc"

hist <- Start(dat = path,
              var = 'tas',
              member = 'r1i1p1f2',
              period = '18500101-20141231',
              lat = indices(1:2), #'all',
              lon = indices(1:2), #'all',
              time = indices(1:730), 
#              transform = CDORemapper,
#              transform_extra_cells = 2,
#              transform_params = list(grid = 'r180x90',
#                                     method = 'conservative',
#                                     crop = FALSE),
#              transform_vars = c('lat', 'lon'),
              synonims = list(lon = c('lon', 'longitude'),
                              lat = c('lat', 'latitude')),
              return_vars = list(time = NULL,
                                 lat = 'dat',
                                 lon = 'dat'),
              retrieve = TRUE)

#---------------------------------------------------------

hist2 <- Start(dat = path,
              var = 'tas',
              member = 'r1i1p1f2',
              period = '18500101-20141231',
              lat = 'all', #indices(1:128), #'all',
              lon = 'all', #indices(1:256), #'all',
              time = values(list(as.POSIXct('1851-01-01 12:00:00 UTC', tz = 'UTC'),
                                 as.POSIXct('1852-12-31 12:00:00 UTC', tz = 'UTC'))),
#              time = values(list(as.POSIXct('1981-01-01 12:00:00 UTC', tz = 'UTC'),
#                                 as.POSIXct('1982-12-31 12:00:00 UTC', tz = 'UTC'))),
              transform = CDORemapper,
              transform_extra_cells = 2,
              transform_params = list(grid = 'r180x90',
                                     method = 'conservative',
                                     crop = FALSE),
              transform_vars = c('lat', 'lon'),
              synonims = list(lon = c('lon', 'longitude'),
                              lat = c('lat', 'latitude')),
              return_vars = list(time = NULL,
                                 lat = 'dat',
                                 lon = 'dat'),
              retrieve = FALSE)

lon <- attributes(hist2)$Varia$dat1$lon
lat <- attributes(hist2)$Varia$dat1$lat
time <- attributes(hist2)$Variable$common$time

climdex_ind <- function(dat, times) {
  datefactor <- as.numeric(substr(times, 1, 4))
  datefactor <- as.factor(datefactor)
  fd <- climdex.pcic::number.days.op.threshold(dat, datefactor, 273.15, "<")
  return(fd)
}

step <- Step(fun = climdex_ind,
               target_dims = 'time',
               output_dims = 'time')

wf <- AddStep(hist2, step, times = time)

#--------------------------------------------------------------

fun <- function(x) {
return(x)
}
step <- Step(fun = fun, target_dims = 'time', output_dims = 'time')
wf <- AddStep(hist2, step)

#--------------------------------------------------------------

## locally
res <- Compute(wf, chunks = list(lat = 1, lon = 2))

