library(startR)

path <- paste0('/esarchive/exp/CMIP6/dcppA-hindcast/EC-Earth3/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/',
               '$member$/Amon/$var$/gr/v20210309/',
               '$var$_Amon_EC-Earth3_dcppA-hindcast_s$sdate$-$member$_gr_$fyear$.nc')
 
narmTRUE <- Start(dataset = path,
                  var = 'psl',
                  sdate = '1970', #paste0(1970:1972),
                  lat = indices(1),
                  lon = indices(1),
#                  fyear = 'all',
#                  fyear = list('1970' = c('197101-197112', '197011-197012')),
#                  fyear = c('197101-197112', '197011-197012'),  #12+2
                  fyear = c('197011-197012', '197101-197112'),  #2+12
## fmonth = 'all' goes to another condition
                  fmonth = 'all',
#                  fmonth = indices(1:24),
#                  fmonth = indices(c(1:2, 13:24)), 
#                  fyear_depends = 'sdate',
                  member = 'r6i2p1f1',
                  fmonth_across = 'fyear',
                  merge_across_dims = TRUE,
                  merge_across_dims_narm = TRUE, 
                  largest_dims_length = TRUE, #c(fmonth = 12),
                  synonims = list(fmonth = c('fmonth','time'), 
                                  lon = c('lon', 'longitude'), 
                                  lat = c('lat', 'latitude')),
                  return_vars = list(lat = 'dataset', lon = 'dataset',
                                     fmonth = 'fyear'),
                  retrieve = TRUE)

narmFALSE <- Start(dataset = path, 
                   var = 'psl',
                   sdate = paste0(1970:1972),
                   lat = indices(1),
                   lon = indices(1),
                   fyear = 'all',
                   fmonth = 'all',
                   fyear_depends = 'sdate',
                   member = 'r6i2p1f1',
                   fmonth_across = 'fyear',
                   merge_across_dims = TRUE,
                   merge_across_dims_narm = FALSE, 
                   largest_dims_length = c(fmonth = 12),
                   synonims = list(fmonth = c('fmonth', 'time'), 
                                   lon = c('lon', 'longitude'), 
                                   lat = c('lat', 'latitude')),
                   return_vars = list(lat = 'dataset', lon = 'dataset',
                                     fmonth = 'fyear'),
                   retrieve = TRUE)

dim(narmTRUE)
dim(narmFALSE)


#=================================
# full
narmTRUE <- Start(dataset = path,
                  var = 'psl',
                  sdate = c("1970", "1971"), #paste0(1970:1972),
                  lat = indices(1),
                  lon = indices(1),
                  fyear = 'all',
                  fmonth = 'all',
#                  fmonth = indices(c(1:2, 13:132)), #indices(1:122), #'all',
                  fyear_depends = 'sdate',
                  member = 'r6i2p1f1',
                  fmonth_across = 'fyear',
                  merge_across_dims = TRUE,
                  merge_across_dims_narm = TRUE,
                  largest_dims_length = c(fmonth = 12),
                  synonims = list(fmonth = c('fmonth','time'),
                                  lon = c('lon', 'longitude'),
                                  lat = c('lat', 'latitude')),
                  return_vars = list(lat = 'dataset', lon = 'dataset',
                                     fmonth = 'fyear'),
                  num_procs = 1 , retrieve = TRUE)

#==============================================
# The case that narm works
## It uses indices(4:27) so it works...
repos <- '/esarchive/exp/ecearth/a1tr/cmorfiles/CMIP/EC-Earth-Consortium/EC-Earth3/historical/$memb$/Omon/$var$/gr/v20190312/$var$_Omon_EC-Earth3_historical_$memb$_gr_$chunk$.nc'
data <- Start(dat = repos,
              var = 'tos',
              memb = 'r24i1p1f1',
              time = indices(4:27), # Apr 1957 to Mar 1959
              chunk = c('195701-195712', '195801-195812', '195901-195912'),  
              lat = indices(1),
              lon = indices(1),
              time_across = 'chunk',
              merge_across_dims = TRUE,
              merge_across_dims_narm = TRUE,
              return_vars = list(lat = NULL, lon = NULL),
              retrieve = TRUE)


