library(startR)

data <- Start(dat = '/esarchive/exp/ecearth/a3w5/original_files/cmorfiles/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/$member$/day/$var$/gr/v20210910/$var$_day_EC-Earth3_dcppA-hindcast_s$sdate$-$member$_gr_$fyear$.nc',
                      var = 'tasmin', 
                      lat = indices(1), 
                      lon = indices(1),
                      sdate = '1960', #paste0(1960:1961), 
                      time = 62:426, ## Jan to Dec (initialised in Nov)
                      time_across = 'fyear',
                      merge_across_dims = TRUE,
                      fyear = 'all', 
#                      fyear_depends = 'sdate', 
                      member = 'r1i4p1f1',
                      synonims = list(lat = c('lat','latitude'), 
                                      lon = c('lon','longitude')),
                      return_vars = list(lat = NULL, lon = NULL, 
                                         time = c('sdate', 'fyear')), 
#                      lon_var = 'lon', lat_var = 'lat',
#                      lat_reorder = Sort(decreasing = FALSE), 
#                      lon_reorder = CircularSort(-180,180),
#                      num_procs = 1, 
                      retrieve = TRUE)

dates <- attr(data,'Variables')$common[['time']]  

dim(dates)
# sdate  time 
#     2   365

