library(startR)

vari <- 'tosmean'
membs_num <- c(24, 28) # c(seq(21,25))
membs <- paste0('r', membs_num, 'i1p1f1')
startdates <- as.character(c(seq(2000, 2002)))
#reg <- 'Nino3.4'
reg <- array('Nino3.4', dim = c(sdate = length(startdates), memb = length(membs), region = 1))
init_month <- 5
length_forecast <- 4
forecast_month <- c(seq(init_month,(init_month+length_forecast-1))) 


# load
path_SR <- paste0('/esarchive/exp/ecearth/a42y/diags/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/$memb$/Omon/$var$/gn/v*/$var$_Omon_EC-Earth3_dcppA-hindcast_s$sdate$-$memb$_gn_$chunk$.nc')
data_exp_call <- Start(dat = path_SR,
                       var = vari,
                       memb = membs,
                       region = reg,
                       region_var = 'region',
                       sdate = startdates,
                       time = c(1:length(forecast_month)), 
                       chunk = 'all',
                       chunk_depends = 'sdate',
                       time_across = 'chunk',
                       merge_across_dims = TRUE,
                       return_vars = list(time=c('sdate','chunk'), region=c('sdate', 'memb')), 
                       retrieve = T)
#--------------------------------------

startdates <- as.character(c(seq(2000, 2002)))
membs <- paste0('r', c(24, 28), 'i1p1f1')
reg_memb <- array('Nino3.4', dim = c(memb = length(membs), region = 1))

# load
path_SR <- paste0('/esarchive/exp/ecearth/a42y/diags/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/$memb$/Omon/$var$/gn/v*/$var$_Omon_EC-Earth3_dcppA-hindcast_s$sdate$-$memb$_gn_$chunk$.nc')
data_memb <- Start(dat = path_SR,
                       var = vari,
                       memb = membs,
                       region = reg_memb,
                       region_var = 'region',
                       sdate = startdates,
                       time = c(1:length(forecast_month)),
                       chunk = 'all',
                       chunk_depends = 'sdate',
                       time_across = 'chunk',
                       merge_across_dims = TRUE,
                       return_vars = list(time=c('sdate','chunk'), region=c('memb')),
                       retrieve = T)


#-------------------------------------

membs <- paste0('r', membs_num, 'i1p1f1')
startdates <- as.character(c(seq(2000, 2015)))
#reg <- 'Nino3.4'
reg <- array('Nino3.4', dim = c(sdate = length(startdates), region = 1))

# load
path_SR <- paste0('/esarchive/exp/ecearth/a42y/diags/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/$memb$/Omon/$var$/gn/v*/$var$_Omon_EC-Earth3_dcppA-hindcast_s$sdate$-$memb$_gn_$chunk$.nc')
data_sdate <- Start(dat = path_SR,
                       var = vari,
                       memb = membs,
                       region = reg,
                       region_var = 'region',
                       sdate = startdates,
                       time = c(1:length(forecast_month)),
                       chunk = 'all',
                       chunk_depends = 'sdate',
                       time_across = 'chunk',
                       merge_across_dims = TRUE,
                       return_vars = list(time=c('sdate','chunk'), region=c('sdate')),
                       retrieve = T)

data <- Start(dat = path_SR,
                       var = vari,
                       memb = membs,
                       region = "Nino3.4",
                       region_var = 'region',
                       sdate = startdates,
                       time = c(1:length(forecast_month)),
                       chunk = 'all',
                       chunk_depends = 'sdate',
                       time_across = 'chunk',
                       merge_across_dims = TRUE,
                       return_vars = list(time=c('sdate','chunk'), region=NULL),
                       retrieve = T)

identical(as.vector(data), as.vector(data_sdate))

