library(lubridate)
tt <-seq(ymd_hms("1995-2-01 18:00:00", tz = "UTC"), ymd_hms("1995-03-01 18:00:00", tz = "UTC"), by = 'days')
tt <- c(tt, tt + years(1), tt + years(2))
time_array <- array(tt, dim = c(time = length(tt)/3, file_date = 3))
time_array <- as.POSIXct(time_array, origin = '1970-01-01', tz = 'UTC')

  hcst <- Start(dat = "/esarchive/exp/ecmwf/system5c3s/daily_mean/$var$_f6h/$var$_$file_date$.nc",
                var = "tas",
                file_date = paste0(1994:1996, '1101'),  #1996 is leap year
                time = time_array, #[time = 91, file_date = 3]
                latitude = indices(1), longitude = indices(1), ensemble = indices(1),
                return_vars = list(latitude = 'dat', longitude = 'dat', time = 'file_date'),
                retrieve = TRUE)

dim(drop(hcst))
#file_date      time 
#        3        91 

time_attr <- attr(hcst, 'Variables')$common$time
dim(time_attr)
#file_date      time 
#        3        92   #WRONG!! Should be 91

#===========================================================

  time_array2 <- time_array
  names(dim(time_array2)) <- c('time', 'sdate')

  hcst_reshape <- Start(dat = "/esarchive/exp/ecmwf/system5c3s/daily_mean/$var$_f6h/$var$_$file_date$.nc",
                var = 'tas',
                file_date = paste0(1994:1996, '1101'),  #1996 is leap year
                time = time_array2,  #[time = 91, sdate = 3]
                time_across = 'file_date',
                merge_across_dims = TRUE,
                split_multiselected_dims = TRUE, 
                latitude = indices(1), longitude = indices(1), ensemble = indices(1),
                return_vars = list(latitude = 'dat', longitude = 'dat', time = 'file_date'),
                retrieve = TRUE)

dim(drop(hcst_reshape))
# time sdate 
#   91     3

time_attr_reshape <- attr(hcst_reshape, 'Variables')$common$time
dim(time_attr_reshape)
# time sdate 
#   91     3 

# Check if data is the same
all.equal(as.vector(drop(hcst)), as.vector(aperm(drop(hcst_reshape), 2:1)))
#[1] TRUE

# Check if the time attribute is correct
all(format(time_array2, '%Y%m%d') == format(attr(hcst_reshape, 'Variables')$common$time, '%Y%m%d'))
[1] TRUE

