path <- "/esarchive/exp/ecmwf/system5_m1/monthly_mean/tas_f6h/tas_20000101.nc"

library(easyNCDF)
file <- NcOpen(path)
arr <- NcToArray(file, 
                 dim_indices = list(time = 1, ensemble = 1, 
                                    latitude = 1:640, longitude = 1:1296),
                 vars_to_read = 'tas')

lats <- NcToArray(file,
                 dim_indices = list(latitude = 1:640), vars_to_read = 'latitude')
lons <- NcToArray(file,
                 dim_indices = list(longitude = 1:1296), vars_to_read = 'longitude')

NcClose(file)

dim(arr)
      var      time  ensemble  latitude longitude 
        1         1         1        75      1296 

dim(lats)
     var latitude 
       1       75




arr2 <- s2dv::CDORemap(arr, lons = as.vector(lons), lats = as.vector(lats),
                       grid = 'r100x50', method = 'con', crop = c(10,20,20,40))

dim(arr2$data_array)
      var      time  ensemble  latitude longitude 
        1         1         1         5         3 

drop(arr2$data_array)[,]
         [,1]     [,2]     [,3]
[1,] 284.9907 285.4820 286.1208
[2,] 282.9882 282.9362 284.3523
[3,] 281.2574 282.6088 285.9198
[4,] 284.1387 287.3716 287.7389
[5,] 285.6547 285.0194 286.1099


arr2 <- s2dv::CDORemap(arr, lons = as.vector(lons), lats = as.vector(lats),
                       grid = 'r100x50', method = 'con', crop = c(10,20,10,50))
 drop(arr2$data_array)[,]
          [,1]     [,2]     [,3]
 [1,]       NA       NA       NA
 [2,]       NA       NA       NA
 [3,] 289.0153 290.1473 288.2607
 [4,] 284.9907 285.4820 286.1208
 [5,] 282.9882 282.9362 284.3523
 [6,] 281.2574 282.6088 285.9198
 [7,] 284.1387 287.3716 287.7389
 [8,] 285.6547 285.0194 286.1099
 [9,] 284.3659 284.3089 284.1408
[10,]       NA       NA       NA
[11,]       NA       NA       NA

#----------------------------------------------
# chunk 1
file <- NcOpen(path)
arr <- NcToArray(file,
                 dim_indices = list(time = 1, ensemble = 1,
                                    latitude = 251:212, longitude = 1:1296),
                 vars_to_read = 'tas')

lats <- NcToArray(file,
                 dim_indices = list(latitude = 251:212), vars_to_read = 'latitude')
lons <- NcToArray(file,
                 dim_indices = list(longitude = 1:1296), vars_to_read = 'longitude')

NcClose(file)

arr2 <- s2dv::CDORemap(arr, lons = as.vector(lons), lats = as.vector(lats),
                       grid = 'r100x50', method = 'con', crop = c(10,20,20,40))

 drop(arr2$data_array)[,]
         [,1]     [,2]     [,3]
[1,] 284.9907 285.4820 286.1208
[2,] 282.9882 282.9362 284.3523
[3,] 281.1705 281.9748 284.1095
[4,]       NA       NA       NA
[5,]       NA       NA       NA

arr2 <- s2dv::CDORemap(arr, lons = as.vector(lons), lats = as.vector(lats),
                       grid = 'r100x50', method = 'con', crop = c(10,20,10,50))
drop(arr2$data_array)[,]
          [,1]     [,2]     [,3]
 [1,]       NA       NA       NA
 [2,]       NA       NA       NA
 [3,] 289.0153 290.1473 288.2607
 [4,] 284.9907 285.4820 286.1208
 [5,] 282.9882 282.9362 284.3523
 [6,] 281.1705 281.9748 284.1095
 [7,]       NA       NA       NA
 [8,]       NA       NA       NA
 [9,]       NA       NA       NA
[10,]       NA       NA       NA
[11,]       NA       NA       NA

#----------------------------------------------
# chunk 2
file <- NcOpen(path)
arr <- NcToArray(file,
                 dim_indices = list(time = 1, ensemble = 1,
                                    latitude = 215:177, longitude = 1:1296),
                 vars_to_read = 'tas')

lats <- NcToArray(file,
                 dim_indices = list(latitude = 215:177), vars_to_read = 'latitude')
lons <- NcToArray(file,
                 dim_indices = list(longitude = 1:1296), vars_to_read = 'longitude')

NcClose(file)

arr2 <- s2dv::CDORemap(arr, lons = as.vector(lons), lats = as.vector(lats),
                       grid = 'r100x50', method = 'con', crop = c(10,20,20,40))

 drop(arr2$data_array)[,]
         [,1]     [,2]     [,3]
[1,]       NA       NA       NA
[2,]       NA       NA       NA
[3,] 281.2961 282.7828 286.4284
[4,] 284.1387 287.3716 287.7389
[5,] 285.6547 285.0194 286.1099



