library(startR)

repos <- paste0('/esarchive/exp/ecmwf/system4_m1/monthly_mean/',
                '$var$_f6h/$var$_$sdate$.nc')
# 20121101 is missing
sdates <- sapply(2012:2014, function(x) paste0(x, sprintf('%02d', 1:12), '01'))  

exp <- Start(dat = repos,
             var = 'tas',
             sdate = sdates,
             time = indices(1),
             ensemble = 1:2,
             latitude = indices(1:2), #'all',
             longitude = indices(1:2), #'all',
             synonims = list(longitude = c('lon', 'longitude'),
                             latitude = c('lat', 'latitude')),
             return_vars = list(longitude = NULL, latitude = NULL),
             retrieve = F)

 func <- function(x) {
   return(x)
 }
 step <- Step(func, target_dims = c('ensemble'),
                    output_dims = c('ensemble'))

 wf <- AddStep(exp, step)

 res_ws <- Compute(wf, chunks = list(sdate = 2))

 temp_dir <- '/gpfs/scratch/bsc32/bsc32734/startR_hpc/'
 ecflow_suite_dir <- '/home/Earth/aho/startR_local/'
 # result's NAs are changed to 0
 res_n4 <- Compute(wf,
                 chunks = list(sdate = 1),
                 threads_load = 2,
                 threads_compute = 4,
                 cluster = list(queue_host = 'nord4',
                   queue_type = 'slurm',
                   temp_dir = temp_dir,
lib_dir = '/.statelite/tmpfs/gpfs/home/bsc32/bsc32734/R/x86_64-pc-linux-gnu-library/3.6',
                   cores_per_job = 2,
                   job_wallclock = '01:00:00',
                   max_jobs = 4,
                   bidirectional = FALSE,
                   polling_period = 10
                 ),
                 ecflow_suite_dir = ecflow_suite_dir,
                 wait = TRUE
                 ) 

