library(startR)
library(testthat)

path_testthat <- '/home/Earth/aho/startR/tests/testthat/'
files_testthat <- list.files(path_testthat)

file_list_each_test <- vector('list', length = length(files_testthat))

for (iii in 4:4) { #1:length(files_testthat)) {
  # clear workspace first
  rm(list = setdiff(ls(), 
                    c("iii", "path_testthat", "files_testthat", 
                      "file_list_each_test")))

  full_path <- paste0(path_testthat, files_testthat[iii])

print(full_path)
  # run the test
  e <- new.env()
  source(full_path, local = e)
  # get the data file
  objects <- ls(envir = e)
  objects_class <- lapply(lapply(objects, get), class)

  startR_obj_retrieve_T <- sapply(objects[which(objects_class == 'startR_array')], get)

  startR_obj_retrieve_F <- sapply(objects[which(objects_class == 'startR_cube')], get)

  files_retrieve_T <- sapply(startR_obj_retrieve_T, attr, 'Files')
  files_retrieve_F <- sapply(startR_obj_retrieve_F, attr, 'ExpectedFiles')
  file_list_each_test[[iii]] <- c(files_retrieve_T, files_retrieve_F)

  print(paste0("The ", iii, "th file, ", files_testthat[iii], ' finished!'))
}

